'use strict';

var _ink = require('ink');

var _ = require('..');

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Demo
class Demo extends _ink.Component {
  constructor() {
    super();

    this.state = {
      value: '',
      selected: null
    };

    this.handleChange = this.handleChange.bind(this);
    this.handleSubmit = this.handleSubmit.bind(this);
  }

  render(props, _ref) {
    let value = _ref.value,
        selected = _ref.selected;

    const countries = [{
      label: 'United Kingdom',
      value: { country: 'United Kingdom', capital: 'London' }
    }, {
      label: 'United States',
      value: { country: 'United States', capital: 'Washington DC' }
    }, {
      label: 'United Arab Emirates',
      value: { country: 'United Arab Emirates', capital: 'Abu Dhabi' }
    }];

    return (0, _ink.h)(
      'div',
      null,
      (0, _ink.h)(
        _ink.Text,
        { green: true },
        'Enter your country: '
      ),
      (0, _ink.h)(_2.default, {
        value: value,
        placeholder: 'Type a country',
        items: countries,
        onChange: this.handleChange,
        onSubmit: this.handleSubmit
      }),
      selected && (0, _ink.h)(
        'span',
        null,
        (0, _ink.h)(
          _ink.Text,
          null,
          'The capital of your country is: '
        ),
        (0, _ink.h)(
          _ink.Text,
          { red: true },
          selected.value.capital
        )
      )
    );
  }

  handleChange(value) {
    this.setState({
      value: value,
      selected: null
    });
  }

  handleSubmit(selected) {
    this.setState({
      selected: selected
    });
  }
}

// Ink
(0, _ink.render)((0, _ink.h)(Demo, null));
