'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ink = require('ink');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _inkSelectInput = require('ink-select-input');

var _inkSelectInput2 = _interopRequireDefault(_inkSelectInput);

var _inkTextInput = require('ink-text-input');

var _inkTextInput2 = _interopRequireDefault(_inkTextInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Helpers -------------------------------------------------------------------

const noop = () => {};
const not = a => !a;
const isEmpty = arr => arr.length === 0;
const getMatch = input => (_ref) => {
  let label = _ref.label;
  return input.length > 0 && label.toLowerCase().indexOf(input.toLowerCase()) > -1;
};

// AutoComplete --------------------------------------------------------------

const AutoComplete = (_ref2) => {
  let value = _ref2.value,
      placeholder = _ref2.placeholder,
      items = _ref2.items,
      getMatch = _ref2.getMatch,
      onChange = _ref2.onChange,
      onSubmit = _ref2.onSubmit,
      indicatorComponent = _ref2.indicatorComponent,
      itemComponent = _ref2.itemComponent;

  const matches = items.filter(getMatch(value));
  const hasSuggestion = not(isEmpty(matches));

  return (0, _ink.h)(
    'span',
    null,
    (0, _ink.h)(
      'div',
      null,
      (0, _ink.h)(_inkTextInput2.default, { value: value, placeholder: placeholder, onChange: onChange })
    ),
    hasSuggestion && (0, _ink.h)(_inkSelectInput2.default, {
      items: matches,
      onSelect: onSubmit,
      focus: hasSuggestion,
      indicatorComponent: indicatorComponent,
      itemComponent: itemComponent
    })
  );
};

AutoComplete.propTypes = {
  value: _propTypes2.default.string,
  placeholder: _propTypes2.default.string,
  items: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    label: _propTypes2.default.string.isRequired,
    value: _propTypes2.default.any.isRequired
  })),
  getMatch: _propTypes2.default.func,
  onChange: _propTypes2.default.func,
  onSubmit: _propTypes2.default.func,
  indicatorComponent: _propTypes2.default.func,
  itemComponent: _propTypes2.default.func
};

AutoComplete.defaultProps = {
  value: '',
  placeholder: '',
  items: [],
  getMatch: getMatch,
  onChange: noop,
  onSubmit: noop,
  indicatorComponent: _inkSelectInput2.default.defaultProps.indicatorComponent,
  itemComponent: _inkSelectInput2.default.defaultProps.itemComponent
};

exports.default = AutoComplete;

// ---------------------------------------------------------------------------